// Variable to store session number for printing out the grade for the session
let sessionNumber = 3;

require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const assert = require('assert');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);

if(!jsonData.gradedTest.s03){

	try {

		//Automated Grading Integration
		// Variable to store passing unit test scores for the session
		let passingTests = 0;
		// Variable to store total number of session unit tests
		let totalTests = 0;

		if (!fs.existsSync('./sessions/frontend/s03/activity/activity-a.html')) {
			throw new Error('File not found');
		}

		if (!fs.existsSync('./sessions/frontend/s03/activity/activity-b.html')) {
			throw new Error('File not found');
		}

		describe(`s0${sessionNumber}`, function() {
			

			this.timeout(30000);
			
			let driver;
			let vars;
		
			let internalCssTestPassed = false;
		
			function parsePixels(value) {
				return parseFloat(value.replace('px', ''));
			}

			let startTime;

			before(async function() {
			  startTime = performance.now();
			  // Any setup code you need to run before the tests start
			  driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()
			});

			const options = new firefox.Options();
			options.headless();

			options.setPreference('browser.download.manager.showWhenStarting', false);
			options.setPreference('browser.download.manager.useWindow', false);

			beforeEach(async function() {

			  totalTests += 1;
			  vars = {}
			})

			afterEach(function(){

				if(this.currentTest.state === "passed"){
					passingTests += 1;
				}

				process.removeAllListeners(); 

			})
	
		
			it('should have the correct first element', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.xpath("//*[contains(text(),\'Science and Engineering Ethics (2001)\')]"))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(tagName).to.equal('em');
			});

			it('should have an h1 or h2 tag with text "Software Engineering Code of Ethics and Professional Practice"', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);

				const elements = await driver.findElements(By.xpath("//*[contains(text(),\'Software Engineering Code of Ethics and Professional Practice\')]"))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(['h1', 'h2']).to.include(tagName.toLowerCase());
			  });

			it('should have an h2 or h3 or h4 tag with text "IEEE-CS/ACM Joint Task Force on Software Engineering Ethics and Professional Practices"', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
				
				const elements = await driver.findElements(By.xpath("//*[contains(text(),\'IEEE-CS/ACM Joint Task Force on Software Engineering Ethics\')]"))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(['h2', 'h3', 'h4']).to.include(tagName.toLowerCase());
			});

			it('should have an p tag with text "code of ethics, professional responsibility, software engineering"', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
				
				const elements = await driver.findElements(By.xpath("/html/body/p[1]"))
				expect(elements.length).to.be.above(0);
				const text = await elements[0].getText();
				expect(text.toLowerCase()).to.include('code of ethics');
				expect(text.toLowerCase()).to.include('professional responsibility');
			});

			it('should have the hr after em element', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.css('em + hr'))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(tagName).to.equal('hr');
			});

			it('should have hr after h3 element', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.css('h3 + hr'))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(tagName).to.equal('hr');
			});

			it('should have h4 after p element with text preamble', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.css('p + h4'))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(tagName).to.equal('h4');
				const text = await elements[0].getText();
				expect(text.toLowerCase()).to.include('preamble');
			});

			it('should have p after h4 element with text The short version of the code', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.css('h4 + p'))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(tagName).to.equal('p');
				const text = await elements[0].getText();
				expect(text.toLowerCase()).to.include('the short version of the code');
			});

			it('should have p after p element with text Software engineers shall commit themselves', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.css('h4 + p + p'))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(tagName).to.equal('p');
				const text = await elements[0].getText();
				expect(text.toLowerCase()).to.include('software engineers shall commit themselves');
			});

			it('should have h4 after p element with text Principles', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.css('h4 + p + p + h4'))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(tagName).to.equal('h4');
				const text = await elements[0].getText();
				expect(text.toLowerCase()).to.include('principles');
			});
		

			it('should have ol after h4 element with text Principles', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.css('h4 + p + p + h4 + ol'))
				expect(elements.length).to.be.equal(1);
			});

			it('should have ol with 8 li elements', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const ol = await driver.findElement(By.css('h4 + p + p + h4 + ol'));
				const liArr = await ol.findElements(By.css('li'));
				expect(liArr.length).to.be.equal(8);
			});

			it('should have 8 li elements with expected text', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const ol = await driver.findElement(By.css('h4 + p + p + h4 + ol'));
				const liArr = await ol.findElements(By.css('li'));

				let liText1 = await liArr[0].getText();
				let liText2 = await liArr[1].getText();
				let liText3 = await liArr[2].getText();
				let liText4 = await liArr[3].getText();
				let liText5 = await liArr[4].getText();
				let liText6 = await liArr[5].getText();
				let liText7 = await liArr[6].getText();
				let liText8 = await liArr[7].getText();

				expect(liText1.toLowerCase()).to.include("software engineers shall act consistently","li does not contain expected text.");
				expect(liText2.toLowerCase()).to.include("software engineers shall act","li does not contain expected text.");
				expect(liText3.toLowerCase()).to.include("software engineers shall ensure","li does not contain expected text.");
				expect(liText4.toLowerCase()).to.include("software engineers shall maintain","li does not contain expected text.");
				expect(liText5.toLowerCase()).to.include("software engineering managers","li does not contain expected text.");
				expect(liText6.toLowerCase()).to.include("software engineers shall advance","li does not contain expected text.");
				expect(liText7.toLowerCase()).to.include("software engineers shall be fair","li does not contain expected text.");
				expect(liText8.toLowerCase()).to.include("software engineers shall participate","li does not contain expected text.");
			});

			it('should have 8 expected text in li to be italicized.', async function() {
								const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-a.html');
				const url = `file://${filePath}`;
				await driver.get(url);
				const ol = await driver.findElement(By.css('h4 + p + p + h4 + ol'));
				const liArr = await ol.findElements(By.css('li'));
				const italic1 = await liArr[0].findElement(By.xpath("//*[contains(text(),\'Public\')]")).getTagName();
				expect(['i', 'em']).to.include(italic1.toLowerCase());
				const italic2 = await liArr[1].findElement(By.xpath("//*[contains(text(),\'Client and employer\')]")).getTagName();
				expect(['i', 'em']).to.include(italic2.toLowerCase());
				const italic3 = await liArr[2].findElement(By.xpath("//*[contains(text(),\'Product\')]")).getTagName();
				expect(['i', 'em']).to.include(italic3.toLowerCase());
				const italic4 = await liArr[3].findElement(By.xpath("//*[contains(text(),\'Judgment\')]")).getTagName();
				expect(['i', 'em']).to.include(italic4.toLowerCase());
				const italic5 = await liArr[4].findElement(By.xpath("//*[contains(text(),\'Management\')]")).getTagName();
				expect(['i', 'em']).to.include(italic5.toLowerCase());
				const italic6 = await liArr[5].findElement(By.xpath("//em[contains(text(),\'Profession\')]")).getTagName();
				expect(['i', 'em']).to.include(italic6.toLowerCase());
				const italic7 = await liArr[6].findElement(By.xpath("//*[contains(text(),\'Colleagues\')]")).getTagName();
				expect(['i', 'em']).to.include(italic7.toLowerCase());
				const italic8 = await liArr[7].findElement(By.xpath("//*[contains(text(),\'Self\')]")).getTagName();
				expect(['i', 'em']).to.include(italic8.toLowerCase());

			});

			it('should have the correct first element activity-b', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const elements = await driver.findElements(By.xpath("//*[contains(text(),\'Code of Ethics of the Filipino Computing and Information Technology Professional\')]"))
				expect(elements.length).to.be.above(0);
				const tagName = await elements[0].getTagName();
				expect(['h1','h2']).to.include(tagName);
			});

			
			it('should have the following element should be a p with text For the purposes of this Code', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[1]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['p']).to.include(tagName);
				const text = await element.getText();
				expect(text.toLowerCase()).to.include("for the purposes of this code");
			});

			it('should have the following element should be a p with strong text information technology', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[2]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['p']).to.include(tagName);
				const text = await element.getText();
				expect(text.toLowerCase()).to.include("information technology");

				const element2 = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[2]//strong"));
				const tagName2 = await element2.getTagName();
				expect(['strong']).to.include(tagName2);

			});

			it('should have the following element should be a p with text the preparation, collection,', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[3]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['p']).to.include(tagName);
				const text = await element.getText();
				expect(text.toLowerCase()).to.include("the preparation, collection, ");
			});

			it('should have the following element should be a p with strong text Information Technology Professional', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[4]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['p']).to.include(tagName);
				const text = await element.getText();
				expect(text.toLowerCase()).to.include("information technology professional");

				const element2 = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[4]//strong"));
				const tagName2 = await element2.getTagName();
				expect(['strong']).to.include(tagName2);

			});

			it('should have the following element should be a p with text  One who develops or provides', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[5]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['p']).to.include(tagName);
				const text = await element.getText();
				expect(text.toLowerCase()).to.include("one who develops or provides");
			});

			it('should have the following element should be a h2 or h3 with text Preamble', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[6]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['h1','h2']).to.include(tagName);
				const text = await element.getText();
				expect(text.toLowerCase()).to.include("preamble");
			});

			it('should have the following element should be a p with text I will use my special knowledge', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[7]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['p']).to.include(tagName);
				const text = await element.getText();
				expect(text.toLowerCase()).to.include("i will use my special knowledge");
			});

			it('should have the following element should be a ul', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s03','activity','activity-b.html');
				const url = `file://${filePath}`;
				await driver.get(url);
		
				const element = await driver.findElement(By.xpath("//h1[contains(text(),'Code of Ethics of the Filipino Computing and Information Technology Professional')]/following-sibling::*[8]"));

				// expect(elements.length).to.be.above(0);
				const tagName = await element.getTagName();
				expect(['ul']).to.include(tagName);

				const liArr = await element.findElements(By.xpath("./child::*"))
				console.log(liArr.length);
				for(let i = 0; i < liArr.length; i++){

					const li = await liArr[i];

					const liChildren = await li.findElements(By.xpath("./child::*"))

					for(let i =0; i < liChildren.length; i++){

						const liChildTagName = await liChildren[0].getTagName();

						expect(liChildTagName).to.include('strong')

						const liChildText = await liChildren[0].getText();

						expect(['promote public knowledge, understanding and appreciation','consider the general welfare and public good','clear and truthful manner','comply and strictly abide by the intellectual property laws, patent laws and other related laws','accept full responsibility for the work undertaken','competence and professionalism','truthful statements','disclose or use any confidential information obtained','without the consent of the parties','except when required by law','try to attain the highest quality','not knowingly participate','commission of fraud and other unlawful acts','uphold and improve','continuing professional development']).to.include(liChildText.toLowerCase())

					}

				}

				let liText1 = await liArr[0].getText();
				let liText2 = await liArr[1].getText();
				let liText3 = await liArr[2].getText();
				let liText4 = await liArr[3].getText();
				let liText5 = await liArr[4].getText();
				let liText6 = await liArr[5].getText();
				let liText7 = await liArr[6].getText();
				let liText8 = await liArr[7].getText();
				let liText9 = await liArr[8].getText();
				let liText10 = await liArr[9].getText();

				expect(liText1.toLowerCase()).to.include("of information technology","li does not contain expected text.");
				expect(liText2.toLowerCase()).to.include("in the performance of my work;","li does not contain expected text.");
				expect(liText3.toLowerCase()).to.include("i will advertise goods or professional services","li does not contain expected text.");
				expect(liText4.toLowerCase()).to.include("i will comply and strictly abide","li does not contain expected text.");
				expect(liText5.toLowerCase()).to.include("and will utilize my skills with","li does not contain expected text.");
				expect(liText6.toLowerCase()).to.include("capabilities and qualities of my products and services","li does not contain expected text.");
				expect(liText7.toLowerCase()).to.include("i will not disclose or use","li does not contain expected text.");
				expect(liText8.toLowerCase()).to.include("i will try to attain","li does not contain expected text.");
				expect(liText9.toLowerCase()).to.include("i will not knowingly","li does not contain expected text.");
				expect(liText10.toLowerCase()).to.include("i will uphold and improve","li does not contain expected text.");

			});

		
		
		  after(async function () {

			// // Wait for all promises to settle before calling driver.quit()
			// await Promise.all(globalThis.PromiseManager.promises);


			const endTime = performance.now();
			const totalTime = (endTime - startTime) / 1000; // Convert to seconds
			console.log(`Total time taken: ${totalTime} seconds`);
  
			global.gradesObject[`s${sessionNumber}`] = {
			  gradeEquivalent: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
			  scoreCount: `${passingTests}/${totalTests}`
			}
		
			jsonData.gradedTest.s03 = true;
			await fs.writeFile('./test/grading.json', JSON.stringify(jsonData,null,4));

			// await driver.close()
			await driver.quit(); 
		  });
		
		})	
	} catch (err) {
		if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
		  console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
		} else {
		  console.log(err)
		}
	  }
} else {
	console.log("S03 - Tested");
}


